<template>
  <div>
    <q-table
      title="Semua User"
      class="table-produk-saya"
      :grid="grid"
      :data="data"
      :columns="columns"
      row-key="id"
      :pagination.sync="pagination"
      :loading="loading"
      :filter="filter"
      @request="onRequest"
      binary-state-sort
    >
      <template v-slot:top-left>
        <div class="q-pa-sm">
          <q-btn label="Tambah Banner" icon="add_circle" color="blue" to="/banner/tambah"  />
        </div>
      </template>
      <template v-slot:top-right style="color: white !important;">
        <div class="q-pa-sm">
          <div class="row">
            <div class="col">
              <q-btn-group>
                <q-btn v-if="!grid" text-color="black" icon="grid_view" @click="grid = true" />
                <q-btn v-else color="blue" icon="list" @click="grid = false" />
<!--                <q-btn color="green" icon="picture_as_pdf" />-->
              </q-btn-group>
            </div>
            <div class="col">
              <q-input dense debounce="300" v-model="filter" style="margin-left: 5px" placeholder="Cari Banner" @input="onRequest" color="white">
                <template v-slot:append style="color: white">
                  <q-icon name="search"  />
                </template>
              </q-input>
            </div>
          </div>
        </div>
      </template>
      <template v-slot:body="props">
        <q-tr :props="props" :key="`m_${props.row.index}`">
          <q-td
            style="width: 30px"
            key="index"
            :props="props"
          >
            {{ props.row.index }}.
          </q-td>
          <q-td key="gambar" :props="props" >
            <q-img :src="props.row.gambar" style="max-width: 100px" @click="showImage(props.row.gambar)"/>
          </q-td>
          <q-td key="judul" :props="props" >
            {{ props.row.judul }}
          </q-td>
          <q-td key="target_url" :props="props" >
            {{ props.row.target_url }}
          </q-td>
          <q-td key="description" :props="props" >
            {{ props.row.description }}
          </q-td>
          <q-td key="start" :props="props" >
            {{ props.row.start }} s/d {{ props.row.end }}
          </q-td>
          <q-td key="status" :props="props" >
            <q-badge color="green" label="Publish" v-if="props.row.status === 1" />
            <q-badge color="red" label="Unpublish" v-else />
          </q-td>


          <q-td key="aksi" :props="props" >
            <q-btn-group>
              <q-btn icon="remove_red_eye" color="green" size="xs" :to="`banner/${props.row.id}`" />
              <q-btn icon="edit" color="yellow" :to="`banner/${props.row.id}/ubah`" size="xs" />
              <q-btn icon="delete" color="red" size="xs" :to="`banner/${props.row.id}/delete`" />
            </q-btn-group>
          </q-td>
        </q-tr>
      </template>
      <template v-slot:item="props">
        <div class="q-pa-xs col-xs-12 col-sm-6 col-md-4">
          <q-card>
            <q-card-section class="text-center">
              <q-img :src="props.row.gambar" style="max-width: 100px" @click="showImage(props.row.gambar)"/>
              <br>
              <strong>{{  props.row.judul }}</strong>
            </q-card-section>
            <q-separator />
            <q-card-section class="flex flex-center">
              <q-list separator class="full-width">
                <q-item clickable v-ripple>
                  <q-item-section>
                    <q-item-label>Deskripsi</q-item-label>
                    <q-item-label caption>{{ props.row.description }}</q-item-label>
                  </q-item-section>
                </q-item>
                <q-item clickable v-ripple>
                  <q-item-section>
                    <q-item-label>Masa Berlaku</q-item-label>
                    <q-item-label caption>{{ props.row.start }} s/d {{ props.row.end }}</q-item-label>
                  </q-item-section>
                </q-item>
                <q-item clickable v-ripple>
                  <q-item-section>
                    <q-item-label>Status</q-item-label>
                    <q-item-label caption>
                      <q-badge color="green" label="Publish" v-if="props.row.status === 1" />
                      <q-badge color="red" label="Unpublish" v-else />
                    </q-item-label>
                  </q-item-section>
                </q-item>
                <q-item clickable v-ripple class="flex flex-center">
                  <q-item-section>
                    <q-btn-group>
                      <q-btn icon="remove_red_eye" color="green" size="xs" :to="`banner/${props.row.id}`" />
                      <q-btn icon="edit" color="yellow" :to="`banner/${props.row.id}/ubah`" size="xs" />
                      <q-btn icon="delete" color="red" size="xs" :to="`banner/${props.row.id}/delete`" />
                    </q-btn-group>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-card-section>
          </q-card>
        </div>
      </template>
    </q-table>
  </div>
</template>

<script>
export default {
  name: "TableBanner",
  data () {
    return {
      filter: '',
      grid: false,
      loading: false,
      token: localStorage.getItem('token'),
      pagination: {
        sortBy: null,
        descending: null,
        page: 1,
        rowsPerPage: 5,
        rowsNumber: 10
      },
      columns: [
        {
          name: 'index',
          required: true,
          label: 'No',
          align: 'left',
          field: 'index',
          format: val => `${val}`,
          sortable: true
        },
        { name: 'gambar', align: 'center', label: 'Gambar', field: 'gambar', sortable: true },
        { name: 'judul', align: 'center', label: 'Judul', field: 'judul', sortable: true },
        { name: 'target_url', align: 'center', label: 'Target Url', field: 'target_url', sortable: true },
        { name: 'description', align: 'center', label: 'Deskripsi', field: 'description', sortable: true },
        { name: 'start', align: 'center', label: 'Masa Berlaku', field: 'start', sortable: true },
        { name: 'status', align: 'center', label: 'Status', field: 'status', sortable: true },
        { name: 'aksi', align: 'center', label: 'Aksi', field: 'id', sortable: false },
      ],
      data: []
    }
  },
  filters: {
    currency (price) {
      return new Intl.NumberFormat('id-ID', {
        style: 'currency',
        currency: 'IDR',
        minimumFractionDigits: 2
      }).format(price)
    }
  },
  beforeMount () {
    this.onRequest({
      pagination: this.pagination,
      filter: undefined
    })
    if (this.$q.platform.is.mobile) {
      this.grid = true
    }
  },
  methods: {
    hapusProduct: function (id) {
      alert(id)
    },
    showImage (val) {
      this.$q.dialog({
        message: `<img src="${val}" style="width: 100%" />`,
        html: true
      })
    },
    onRequest (props) {
      const { descending, page, rowsPerPage, sortBy } = props.pagination
      const filter = props.filter
      this.loading = true
      const apiUrl =
        `api/banner?page=${page}&perPage=${rowsPerPage}&sortBy=${sortBy}&filter=${filter}&descending=${descending}`

      const config = {
        method: 'get',
        url: apiUrl,
        headers: {
          Authorization: 'Bearer ' + this.token
        }
      }

      this.$axios(config)
        .then(response => {
          const data = response.data

          this.data = data.data

          this.data.forEach((row, index) => {
            row.index = index + 1 + ((page - 1) * rowsPerPage)
          })
          this.pagination.page = data.current_page
          this.pagination.rowsPerPage = data.per_page
          this.pagination.rowsNumber = data.total
          this.pagination.sortBy = props.pagination.sortBy || 'index'
          this.pagination.descending = props.pagination.descending || false
        })
        .catch(error => {
          console.log(error)
        })
        .then(always => {
          this.loading = false
        })
    }
  }
}
</script>

<style lang="sass" scoped>
.q-table--no-wrap td
  white-space: normal

  .table-produk-saya

    .q-table__top,
    .q-table__bottom,
    thead tr:first-child th
      /* bg color is important for th; just specify one */
      background-color: #009688
      color: white
      font-size: 16px

    thead tr th
      position: sticky
      z-index: 1
    thead tr:first-child th
      top: 0

    /* this is when the loading indicator appears */
    &.q-table--loading thead tr:last-child th
      /* height of all previous header rows */
      top: 48px
</style>
